<?php

declare(strict_types=1);

/**
 * This file is part of the CSasWebApi package
 *
 * https://github.com/Spoje-NET/php-csas-webapi
 *
 * (c) SpojeNetIT <http://spoje.net/>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

/**
 * Production Accounts API V3.
 *
 * API for managing production accounts.
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: vitezslav.dvorak@spojenet.cz
 * Generated by: https://openapi-generator.tech
 * Generator version: 7.10.0
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SpojeNet\CSas\Model;

use SpojeNet\CSas\ObjectSerializer;

/**
 * Account Class Doc Comment.
 *
 * @category Class
 *
 * @author   OpenAPI Generator team
 *
 * @see     https://openapi-generator.tech
 *
 * @implements \ArrayAccess<string, mixed>
 */
class Account implements \ArrayAccess, \JsonSerializable, ModelInterface
{
    public const DISCRIMINATOR = null;
    public const STATUS_BOOK = 'BOOK';
    public const STATUS_PENDING = 'PENDING';

    /**
     * The original name of the model.
     */
    protected static string $openAPIModelName = 'Account';

    /**
     * Array of property to type mappings. Used for (de)serialization.
     *
     * @var string[]
     */
    protected static array $openAPITypes = [
        'id' => 'string',
        'identification' => '\SpojeNet\CSas\Model\AccountIdentification',
        'currency' => 'string',
        'servicer' => '\SpojeNet\CSas\Model\AccountServicer',
        'nameI18N' => 'string',
        'productI18N' => 'string',
        'ownersNames' => 'string[]',
        'relationship' => '\SpojeNet\CSas\Model\AccountRelationship',
        'suitableScope' => '\SpojeNet\CSas\Model\AccountSuitableScope',
        'status' => 'string',
        'relatedAgents' => '\SpojeNet\CSas\Model\AccountRelatedAgents',
        'currencyExchange' => '\SpojeNet\CSas\Model\AccountCurrencyExchange',
    ];

    /**
     * Array of property to format mappings. Used for (de)serialization.
     *
     * @var string[]
     *
     * @phpstan-var array<string, string|null>
     *
     * @psalm-var array<string, string|null>
     */
    protected static array $openAPIFormats = [
        'id' => null,
        'identification' => null,
        'currency' => null,
        'servicer' => null,
        'nameI18N' => null,
        'productI18N' => null,
        'ownersNames' => null,
        'relationship' => null,
        'suitableScope' => null,
        'status' => null,
        'relatedAgents' => null,
        'currencyExchange' => null,
    ];

    /**
     * Array of nullable properties. Used for (de)serialization.
     *
     * @var bool[]
     */
    protected static array $openAPINullables = [
        'id' => false,
        'identification' => false,
        'currency' => false,
        'servicer' => false,
        'nameI18N' => false,
        'productI18N' => false,
        'ownersNames' => false,
        'relationship' => false,
        'suitableScope' => false,
        'status' => false,
        'relatedAgents' => false,
        'currencyExchange' => false,
    ];

    /**
     * If a nullable field gets set to null, insert it here.
     *
     * @var bool[]
     */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name.
     *
     * @var string[]
     */
    protected static array $attributeMap = [
        'id' => 'id',
        'identification' => 'identification',
        'currency' => 'currency',
        'servicer' => 'servicer',
        'nameI18N' => 'nameI18N',
        'productI18N' => 'productI18N',
        'ownersNames' => 'ownersNames',
        'relationship' => 'relationship',
        'suitableScope' => 'suitableScope',
        'status' => 'status',
        'relatedAgents' => 'relatedAgents',
        'currencyExchange' => 'currencyExchange',
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses).
     *
     * @var string[]
     */
    protected static array $setters = [
        'id' => 'setId',
        'identification' => 'setIdentification',
        'currency' => 'setCurrency',
        'servicer' => 'setServicer',
        'nameI18N' => 'setNameI18N',
        'productI18N' => 'setProductI18N',
        'ownersNames' => 'setOwnersNames',
        'relationship' => 'setRelationship',
        'suitableScope' => 'setSuitableScope',
        'status' => 'setStatus',
        'relatedAgents' => 'setRelatedAgents',
        'currencyExchange' => 'setCurrencyExchange',
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests).
     *
     * @var string[]
     */
    protected static array $getters = [
        'id' => 'getId',
        'identification' => 'getIdentification',
        'currency' => 'getCurrency',
        'servicer' => 'getServicer',
        'nameI18N' => 'getNameI18N',
        'productI18N' => 'getProductI18N',
        'ownersNames' => 'getOwnersNames',
        'relationship' => 'getRelationship',
        'suitableScope' => 'getSuitableScope',
        'status' => 'getStatus',
        'relatedAgents' => 'getRelatedAgents',
        'currencyExchange' => 'getCurrencyExchange',
    ];

    /**
     * Associative array for storing property values.
     *
     * @var mixed[]
     */
    protected array $container = [];

    /**
     * Constructor.
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(?array $data = null)
    {
        $this->setIfExists('id', $data ?? [], null);
        $this->setIfExists('identification', $data ?? [], null);
        $this->setIfExists('currency', $data ?? [], null);
        $this->setIfExists('servicer', $data ?? [], null);
        $this->setIfExists('nameI18N', $data ?? [], null);
        $this->setIfExists('productI18N', $data ?? [], null);
        $this->setIfExists('ownersNames', $data ?? [], null);
        $this->setIfExists('relationship', $data ?? [], null);
        $this->setIfExists('suitableScope', $data ?? [], null);
        $this->setIfExists('status', $data ?? [], null);
        $this->setIfExists('relatedAgents', $data ?? [], null);
        $this->setIfExists('currencyExchange', $data ?? [], null);
    }

    /**
     * Gets the string presentation of the object.
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            \JSON_PRETTY_PRINT,
        );
    }

    /**
     * Array of property to type mappings. Used for (de)serialization.
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization.
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Checks if a property is nullable.
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     */
    public function isNullableSetToNull(string $property): bool
    {
        return \in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name.
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses).
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests).
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    /**
     * Gets allowable values of the enum.
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_BOOK,
            self::STATUS_PENDING,
        ];
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getStatusAllowableValues();

        if (null !== $this->container['status'] && !\in_array($this->container['status'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'status', must be one of '%s'",
                $this->container['status'],
                implode("', '", $allowedValues),
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed.
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return \count($this->listInvalidProperties()) === 0;
    }

    /**
     * Gets id.
     *
     * @return null|string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id.
     *
     * @param null|string $id Unique system ID of the client's account
     *
     * @return self
     */
    public function setId($id)
    {
        if (null === $id) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }

        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets identification.
     *
     * @return null|\SpojeNet\CSas\Model\AccountIdentification
     */
    public function getIdentification()
    {
        return $this->container['identification'];
    }

    /**
     * Sets identification.
     *
     * @param null|\SpojeNet\CSas\Model\AccountIdentification $identification identification
     *
     * @return self
     */
    public function setIdentification($identification)
    {
        if (null === $identification) {
            throw new \InvalidArgumentException('non-nullable identification cannot be null');
        }

        $this->container['identification'] = $identification;

        return $this;
    }

    /**
     * Gets currency.
     *
     * @return null|string
     */
    public function getCurrency()
    {
        return $this->container['currency'];
    }

    /**
     * Sets currency.
     *
     * @param null|string $currency Currency of the account
     *
     * @return self
     */
    public function setCurrency($currency)
    {
        if (null === $currency) {
            throw new \InvalidArgumentException('non-nullable currency cannot be null');
        }

        $this->container['currency'] = $currency;

        return $this;
    }

    /**
     * Gets servicer.
     *
     * @return null|\SpojeNet\CSas\Model\AccountServicer
     */
    public function getServicer()
    {
        return $this->container['servicer'];
    }

    /**
     * Sets servicer.
     *
     * @param null|\SpojeNet\CSas\Model\AccountServicer $servicer servicer
     *
     * @return self
     */
    public function setServicer($servicer)
    {
        if (null === $servicer) {
            throw new \InvalidArgumentException('non-nullable servicer cannot be null');
        }

        $this->container['servicer'] = $servicer;

        return $this;
    }

    /**
     * Gets nameI18N.
     *
     * @return null|string
     */
    public function getNameI18N()
    {
        return $this->container['nameI18N'];
    }

    /**
     * Sets nameI18N.
     *
     * @param null|string $nameI18N Internationalized name of the account
     *
     * @return self
     */
    public function setNameI18N($nameI18N)
    {
        if (null === $nameI18N) {
            throw new \InvalidArgumentException('non-nullable nameI18N cannot be null');
        }

        $this->container['nameI18N'] = $nameI18N;

        return $this;
    }

    /**
     * Gets productI18N.
     *
     * @return null|string
     */
    public function getProductI18N()
    {
        return $this->container['productI18N'];
    }

    /**
     * Sets productI18N.
     *
     * @param null|string $productI18N Internationalized product name
     *
     * @return self
     */
    public function setProductI18N($productI18N)
    {
        if (null === $productI18N) {
            throw new \InvalidArgumentException('non-nullable productI18N cannot be null');
        }

        $this->container['productI18N'] = $productI18N;

        return $this;
    }

    /**
     * Gets ownersNames.
     *
     * @return null|string[]
     */
    public function getOwnersNames()
    {
        return $this->container['ownersNames'];
    }

    /**
     * Sets ownersNames.
     *
     * @param null|string[] $ownersNames List of account owners' names
     *
     * @return self
     */
    public function setOwnersNames($ownersNames)
    {
        if (null === $ownersNames) {
            throw new \InvalidArgumentException('non-nullable ownersNames cannot be null');
        }

        $this->container['ownersNames'] = $ownersNames;

        return $this;
    }

    /**
     * Gets relationship.
     *
     * @return null|\SpojeNet\CSas\Model\AccountRelationship
     */
    public function getRelationship()
    {
        return $this->container['relationship'];
    }

    /**
     * Sets relationship.
     *
     * @param null|\SpojeNet\CSas\Model\AccountRelationship $relationship relationship
     *
     * @return self
     */
    public function setRelationship($relationship)
    {
        if (null === $relationship) {
            throw new \InvalidArgumentException('non-nullable relationship cannot be null');
        }

        $this->container['relationship'] = $relationship;

        return $this;
    }

    /**
     * Gets suitableScope.
     *
     * @return null|\SpojeNet\CSas\Model\AccountSuitableScope
     */
    public function getSuitableScope()
    {
        return $this->container['suitableScope'];
    }

    /**
     * Sets suitableScope.
     *
     * @param null|\SpojeNet\CSas\Model\AccountSuitableScope $suitableScope suitableScope
     *
     * @return self
     */
    public function setSuitableScope($suitableScope)
    {
        if (null === $suitableScope) {
            throw new \InvalidArgumentException('non-nullable suitableScope cannot be null');
        }

        $this->container['suitableScope'] = $suitableScope;

        return $this;
    }

    /**
     * Gets status.
     *
     * @return null|string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status.
     *
     * @param null|string $status Status of the account
     *
     * @return self
     */
    public function setStatus($status)
    {
        if (null === $status) {
            throw new \InvalidArgumentException('non-nullable status cannot be null');
        }

        $allowedValues = $this->getStatusAllowableValues();

        if (!\in_array($status, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'status', must be one of '%s'",
                    $status,
                    implode("', '", $allowedValues),
                ),
            );
        }

        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets relatedAgents.
     *
     * @return null|\SpojeNet\CSas\Model\AccountRelatedAgents
     */
    public function getRelatedAgents()
    {
        return $this->container['relatedAgents'];
    }

    /**
     * Sets relatedAgents.
     *
     * @param null|\SpojeNet\CSas\Model\AccountRelatedAgents $relatedAgents relatedAgents
     *
     * @return self
     */
    public function setRelatedAgents($relatedAgents)
    {
        if (null === $relatedAgents) {
            throw new \InvalidArgumentException('non-nullable relatedAgents cannot be null');
        }

        $this->container['relatedAgents'] = $relatedAgents;

        return $this;
    }

    /**
     * Gets currencyExchange.
     *
     * @return null|\SpojeNet\CSas\Model\AccountCurrencyExchange
     */
    public function getCurrencyExchange()
    {
        return $this->container['currencyExchange'];
    }

    /**
     * Sets currencyExchange.
     *
     * @param null|\SpojeNet\CSas\Model\AccountCurrencyExchange $currencyExchange currencyExchange
     *
     * @return self
     */
    public function setCurrencyExchange($currencyExchange)
    {
        if (null === $currencyExchange) {
            throw new \InvalidArgumentException('non-nullable currencyExchange cannot be null');
        }

        $this->container['currencyExchange'] = $currencyExchange;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param int $offset Offset
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param int $offset Offset
     *
     * @return null|mixed
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param null|int $offset Offset
     * @param mixed    $value  Value to be set
     */
    public function offsetSet($offset, $value): void
    {
        if (null === $offset) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param int $offset Offset
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     *
     * @see https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed returns data which can be serialized by json_encode(), which is a value
     *               of any type other than a resource
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
        return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets a header-safe presentation of the object.
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
     * Array of nullable properties.
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null.
     *
     * @return bool[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Setter - Array of nullable field names deliberately set to null.
     *
     * @param bool[] $openAPINullablesSetToNull
     */
    private function setOpenAPINullablesSetToNull(array $openAPINullablesSetToNull): void
    {
        $this->openAPINullablesSetToNull = $openAPINullablesSetToNull;
    }

    /**
     * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
     * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
     * $this->openAPINullablesSetToNull array.
     *
     * @param mixed $defaultValue
     */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && \array_key_exists($variableName, $fields) && null === $fields[$variableName]) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }
}
